(window.webpackJsonp=window.webpackJsonp||[]).push([[21],{232:function(e,t,a){"use strict";a.r(t);var s=a(0),n=Object(s.a)({},(function(){var e=this,t=e.$createElement,a=e._self._c||t;return a("ContentSlotsDistributor",{attrs:{"slot-key":e.$parent.slotKey}},[a("h1",{attrs:{id:"validation"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#validation"}},[e._v("#")]),e._v(" Validation")]),e._v(" "),a("p"),a("div",{staticClass:"table-of-contents"},[a("ul",[a("li",[a("a",{attrs:{href:"#introduction"}},[e._v("Introduction")])]),a("li",[a("a",{attrs:{href:"#rules-sets"}},[e._v("Rules sets")])]),a("li",[a("a",{attrs:{href:"#available-validation-rules"}},[e._v("Available validation rules")])]),a("li",[a("a",{attrs:{href:"#custom-rules"}},[e._v("Custom rules")])]),a("li",[a("a",{attrs:{href:"#placeholders"}},[e._v("Placeholders")]),a("ul",[a("li",[a("a",{attrs:{href:"#available-placeholders"}},[e._v("Available placeholders")])])])])])]),a("p"),e._v(" "),a("h2",{attrs:{id:"introduction"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#introduction"}},[e._v("#")]),e._v(" Introduction")]),e._v(" "),a("p",[e._v("Goyave provides a powerful, yet easy way to validate all incoming data, no matter its type or its format, thanks to a large number of validation rules.")]),e._v(" "),a("p",[e._v("Incoming requests are validated using "),a("strong",[e._v("rules set")]),e._v(", which associate rules with each expected field in the request.")]),e._v(" "),a("p",[e._v("Validation rules can "),a("strong",[e._v("alter the raw data")]),e._v(". That means that when you validate a field to be number, if the validation passes, you are ensured that the data you'll be using in your controller handler is a "),a("code",[e._v("float64")]),e._v(". Or if you're validating an IP, you get a "),a("code",[e._v("net.IP")]),e._v(" object.")]),e._v(" "),a("p",[e._v("If a request contains a field with a "),a("code",[e._v("nil")]),e._v("/"),a("code",[e._v("null")]),e._v(" value, and that this field doesn't have the "),a("code",[e._v("nullable")]),e._v(" rule, the field is "),a("strong",[e._v("removed")]),e._v(" entirely from the request.")]),e._v(" "),a("p",[e._v("Validation is automatic. You just have to define a rules set and assign it to a route. When the validation doesn't pass, the request is stopped and the validation errors messages are sent as a response, using the correct "),a("a",{attrs:{href:"../advanced/localization"}},[e._v("language")]),e._v(". The HTTP response code of failed validation is "),a("strong",[e._v('422 "Unprocessable Entity"')]),e._v(", or "),a("strong",[e._v('400 "Bad Request"')]),e._v(" if the body could not be parsed.")]),e._v(" "),a("div",{staticClass:"custom-block tip"},[a("p",{staticClass:"custom-block-title"},[e._v("TIP")]),e._v(" "),a("p",[e._v("You can customize the validation error messages by editing "),a("code",[e._v("resources/lang/<language>/rules.json")]),e._v(". Learn more in the "),a("a",{attrs:{href:"../advanced/localization"}},[e._v("localization")]),e._v(" section.")])]),e._v(" "),a("p",[e._v("The following features require the "),a("code",[e._v("validation")]),e._v(" package to be imported.")]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("import")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"github.com/System-Glitch/goyave/v2/validation"')]),e._v("\n")])])]),a("h2",{attrs:{id:"rules-sets"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#rules-sets"}},[e._v("#")]),e._v(" Rules sets")]),e._v(" "),a("p",[e._v("The "),a("code",[e._v("http/request")]),e._v(" directory contains the requests validation rules sets. You should have one package per feature, regrouping all requests handled by the same controller. The package should be named "),a("code",[e._v("<feature_name>request")]),e._v(".")]),e._v(" "),a("p",[a("strong",[e._v("Example:")]),e._v(" ("),a("code",[e._v("http/request/productrequest/product.go")]),e._v(")")]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("var")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("\n\tStore validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("RuleSet "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v("=")]),e._v(" validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("RuleSet"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n\t\t"),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"name"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(":")]),e._v("  "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"required"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"string"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"between:3,50"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v("\n\t\t"),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"price"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(":")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"required"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"numeric"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"min:0.01"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v("\n\t\t"),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"image"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(":")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"nullable"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"file"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"image"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"max:2048"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"count:1"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v("\n    "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n    \n    "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v("// ...")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n")])])]),a("div",{staticClass:"custom-block warning"},[a("p",{staticClass:"custom-block-title"},[e._v("WARNING")]),e._v(" "),a("p",[a("strong",[e._v("The order in which you assign rules is important")]),e._v(", as rules are executed in this order. The rules checking for the type of the data should "),a("strong",[e._v("always be first")]),e._v(", or after "),a("code",[e._v("required")]),e._v(" and "),a("code",[e._v("nullable")]),e._v(".")]),e._v(" "),a("p",[e._v("If a field is not "),a("strong",[e._v("required")]),e._v(" and is missing from the request, "),a("strong",[e._v("no rules are checked")]),e._v("!")])]),e._v(" "),a("div",{staticClass:"custom-block tip"},[a("p",{staticClass:"custom-block-title"},[e._v("TIP")]),e._v(" "),a("p",[a("code",[e._v("validation.RuleSet")]),e._v(" is an alias for "),a("code",[e._v("map[string][]string")])])]),e._v(" "),a("hr"),e._v(" "),a("p",[e._v("Once your rules sets are defined, you need to assign them to your routes. The rule set for a route is the last parameter of the route definition. Learn more about routing in the "),a("a",{attrs:{href:"./routing"}},[e._v("dedicated section")]),e._v(".")]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[e._v("router"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("Route")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"POST"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"/product"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" product"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("Store"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" productrequest"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("Store"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n")])])]),a("h2",{attrs:{id:"available-validation-rules"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#available-validation-rules"}},[e._v("#")]),e._v(" Available validation rules")]),e._v(" "),a("div",{staticClass:"table"},[a("p",[a("a",{attrs:{href:"#required"}},[e._v("Required")]),e._v(" "),a("a",{attrs:{href:"#nullable"}},[e._v("Nullable")]),e._v(" "),a("a",{attrs:{href:"#numeric"}},[e._v("Numeric")]),e._v(" "),a("a",{attrs:{href:"#integer"}},[e._v("Integer")]),e._v(" "),a("a",{attrs:{href:"#min-value"}},[e._v("Min")]),e._v(" "),a("a",{attrs:{href:"#max-value"}},[e._v("Max")]),e._v(" "),a("a",{attrs:{href:"#between-min-max"}},[e._v("Between")]),e._v(" "),a("a",{attrs:{href:"#greater-than-field"}},[e._v("Greater than")]),e._v(" "),a("a",{attrs:{href:"#greater-than-equal-field"}},[e._v("Greater than or equal")]),e._v(" "),a("a",{attrs:{href:"#lower-than-field"}},[e._v("Lower than")]),e._v(" "),a("a",{attrs:{href:"#lower-than-equal-field"}},[e._v("Lower than or equal")]),e._v(" "),a("a",{attrs:{href:"#string"}},[e._v("String")]),e._v(" "),a("a",{attrs:{href:"#array"}},[e._v("Array")]),e._v(" "),a("a",{attrs:{href:"#distinct"}},[e._v("Distinct")]),e._v(" "),a("a",{attrs:{href:"#digits"}},[e._v("Digits")]),e._v(" "),a("a",{attrs:{href:"#regex-pattern"}},[e._v("Regex")]),e._v(" "),a("a",{attrs:{href:"#email"}},[e._v("Email")]),e._v(" "),a("a",{attrs:{href:"#size-value"}},[e._v("Size")]),e._v(" "),a("a",{attrs:{href:"#alpha"}},[e._v("Alpha")]),e._v(" "),a("a",{attrs:{href:"#alpha-dash"}},[e._v("Alpha dash")]),e._v(" "),a("a",{attrs:{href:"#alpha-num"}},[e._v("Alpha numeric")]),e._v(" "),a("a",{attrs:{href:"#starts-with-value1"}},[e._v("Starts with")]),e._v(" "),a("a",{attrs:{href:"#ends-with-value1"}},[e._v("Ends with")]),e._v(" "),a("a",{attrs:{href:"#in-value1-value2"}},[e._v("In")]),e._v(" "),a("a",{attrs:{href:"#not-in-value1-value2"}},[e._v("Not in")]),e._v(" "),a("a",{attrs:{href:"#in-array-field"}},[e._v("In array")]),e._v(" "),a("a",{attrs:{href:"#not-in-array-field"}},[e._v("Not in array")]),e._v(" "),a("a",{attrs:{href:"#timezone"}},[e._v("Timezone")]),e._v(" "),a("a",{attrs:{href:"#ip"}},[e._v("IP")]),e._v(" "),a("a",{attrs:{href:"#ipv4"}},[e._v("IPv4")]),e._v(" "),a("a",{attrs:{href:"#ipv6"}},[e._v("IPv6")]),e._v(" "),a("a",{attrs:{href:"#json"}},[e._v("JSON")]),e._v(" "),a("a",{attrs:{href:"#url"}},[e._v("URL")]),e._v(" "),a("a",{attrs:{href:"#uuid-version"}},[e._v("UUID")]),e._v(" "),a("a",{attrs:{href:"#bool"}},[e._v("Bool")]),e._v(" "),a("a",{attrs:{href:"#same-field"}},[e._v("Same")]),e._v(" "),a("a",{attrs:{href:"#different-field"}},[e._v("Different")]),e._v(" "),a("a",{attrs:{href:"#confirmed"}},[e._v("Confirmed")]),e._v(" "),a("a",{attrs:{href:"#file"}},[e._v("File")]),e._v(" "),a("a",{attrs:{href:"#mime-foo"}},[e._v("MIME")]),e._v(" "),a("a",{attrs:{href:"#image"}},[e._v("Image")]),e._v(" "),a("a",{attrs:{href:"#extension-foo"}},[e._v("Extension")]),e._v(" "),a("a",{attrs:{href:"#count-value"}},[e._v("Count")]),e._v(" "),a("a",{attrs:{href:"#count-min-value"}},[e._v("Count min")]),e._v(" "),a("a",{attrs:{href:"#count-max-value"}},[e._v("Count max")]),e._v(" "),a("a",{attrs:{href:"#count-between-min-max"}},[e._v("Count between")]),e._v(" "),a("a",{attrs:{href:"#date-format"}},[e._v("Date")]),e._v(" "),a("a",{attrs:{href:"#before-date"}},[e._v("Before")]),e._v(" "),a("a",{attrs:{href:"#before-equal-date"}},[e._v("Before or equal")]),e._v(" "),a("a",{attrs:{href:"#after-date"}},[e._v("After")]),e._v(" "),a("a",{attrs:{href:"#after-equal-date"}},[e._v("After or equal")]),e._v(" "),a("a",{attrs:{href:"#date-equals-date"}},[e._v("Date equals")]),e._v(" "),a("a",{attrs:{href:"#date-between-date1-date2"}},[e._v("Date between")])])]),a("h4",{attrs:{id:"required"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#required"}},[e._v("#")]),e._v(" required")]),e._v(" "),a("p",[e._v("The field under validation must be present.")]),e._v(" "),a("p",[e._v("If the field is a string, the string must not be empty. If a field is "),a("code",[e._v("null")]),e._v(" and has the "),a("code",[e._v("nullable")]),e._v(" rule, the "),a("code",[e._v("required")]),e._v(" rules passes. As non-nullable fields are removed if they have a "),a("code",[e._v("null")]),e._v(" value, the "),a("code",[e._v("required")]),e._v(" rule doesn't pass if a field is "),a("code",[e._v("null")]),e._v(" and doesn't have the "),a("code",[e._v("nullable")]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"nullable"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#nullable"}},[e._v("#")]),e._v(" nullable")]),e._v(" "),a("p",[e._v("The field under validation can have a "),a("code",[e._v("nil")]),e._v("/"),a("code",[e._v("null")]),e._v(" value. If this rule is missing from the rules set, the field will be "),a("strong",[e._v("removed")]),e._v(" if it is "),a("code",[e._v("null")]),e._v(". This rule is especially useful when working with JSON requests or with primitives that can contain null values.")]),e._v(" "),a("p",[e._v("Be sure to check if your field is not null before using it in your handlers.")]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token comment"}},[e._v("// In this example, field is numeric")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("if")]),e._v(" val"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" exists "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v(":=")]),e._v(" request"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("Data"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"field"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(";")]),e._v(" exists "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v("&&")]),e._v(" val "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v("!=")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token boolean"}},[e._v("nil")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n    field"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token boolean"}},[e._v("_")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v(":=")]),e._v(" request"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),e._v("Data"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"field"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("float64")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n")])])]),a("h4",{attrs:{id:"numeric"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#numeric"}},[e._v("#")]),e._v(" numeric")]),e._v(" "),a("p",[e._v("The field under validation must be numeric. Strings that can be converted to numbers are accepted.\nThis rule converts the field to "),a("code",[e._v("float64")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"integer"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#integer"}},[e._v("#")]),e._v(" integer")]),e._v(" "),a("p",[e._v("The field under validation must be an integer. Strings that can be converted to an integer are accepted.\nThis rule converts the field to "),a("code",[e._v("int")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"min-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#min-value"}},[e._v("#")]),e._v(" min:value")]),e._v(" "),a("p",[e._v("Depending on its type, the field under validation must be at least "),a("code",[e._v("min")]),e._v(".\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"max-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#max-value"}},[e._v("#")]),e._v(" max:value")]),e._v(" "),a("p",[e._v("Depending on its type, the field under validation must not be superior to "),a("code",[e._v("value")]),e._v(".\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"between-min-max"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#between-min-max"}},[e._v("#")]),e._v(" between:min,max")]),e._v(" "),a("p",[e._v("Depending on its type, the field under validation must be between "),a("code",[e._v("min")]),e._v(" and "),a("code",[e._v("max")]),e._v(".\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"greater-than-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#greater-than-field"}},[e._v("#")]),e._v(" greater_than:field")]),e._v(" "),a("p",[e._v("The field under validation must be greater than the given "),a("code",[e._v("field")]),e._v(". The two fields must have the same type.\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"greater-than-equal-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#greater-than-equal-field"}},[e._v("#")]),e._v(" greater_than_equal:field")]),e._v(" "),a("p",[e._v("The field under validation must be greater or equal to the given "),a("code",[e._v("field")]),e._v(". The two fields must have the same type.\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"lower-than-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#lower-than-field"}},[e._v("#")]),e._v(" lower_than:field")]),e._v(" "),a("p",[e._v("The field under validation must be lower than the given "),a("code",[e._v("field")]),e._v(". The two fields must have the same type.\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"lower-than-equal-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#lower-than-equal-field"}},[e._v("#")]),e._v(" lower_than_equal:field")]),e._v(" "),a("p",[e._v("The field under validation must be lower or equal to the given "),a("code",[e._v("field")]),e._v(". The two fields must have the same type.\nStrings, numerics, array, and files are evaluated using the same method as the "),a("a",{attrs:{href:"#size-value"}},[a("code",[e._v("size")])]),e._v(" rule.")]),e._v(" "),a("h4",{attrs:{id:"string"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#string"}},[e._v("#")]),e._v(" string")]),e._v(" "),a("p",[e._v("The field under validation must be a string.")]),e._v(" "),a("h4",{attrs:{id:"array"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#array"}},[e._v("#")]),e._v(" array")]),e._v(" "),a("p",[e._v("The field under validation must be an array. In a handler, the data is get as a "),a("code",[e._v("[]interface{}")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"distinct"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#distinct"}},[e._v("#")]),e._v(" distinct")]),e._v(" "),a("p",[e._v("The field under validation must be an array and have distinct values.")]),e._v(" "),a("h4",{attrs:{id:"digits"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#digits"}},[e._v("#")]),e._v(" digits")]),e._v(" "),a("p",[e._v("The field under validation must be a string and contain only digits.")]),e._v(" "),a("h4",{attrs:{id:"regex-pattern"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#regex-pattern"}},[e._v("#")]),e._v(" regex:pattern")]),e._v(" "),a("p",[e._v("The field under validation must be a string and match the given "),a("code",[e._v("pattern")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"email"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#email"}},[e._v("#")]),e._v(" email")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be an email address.")]),e._v(" "),a("div",{staticClass:"custom-block warning"},[a("p",{staticClass:"custom-block-title"},[e._v("WARNING")]),e._v(" "),a("p",[e._v("This rule is not enough to properly validate email addresses. The only way to ensure an email address is valid is by sending a confirmation email.")])]),e._v(" "),a("h4",{attrs:{id:"size-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#size-value"}},[e._v("#")]),e._v(" size:value")]),e._v(" "),a("p",[e._v("Depending on its type, the field under validation must:")]),e._v(" "),a("ul",[a("li",[e._v("Strings: have a length of "),a("code",[e._v("value")]),e._v(" characters.")]),e._v(" "),a("li",[e._v("Numerics: be equal to "),a("code",[e._v("value")]),e._v(".")]),e._v(" "),a("li",[e._v("Arrays: exactly have "),a("code",[e._v("value")]),e._v(" items.")]),e._v(" "),a("li",[e._v("Files: weigth exactly "),a("code",[e._v("value")]),e._v(" KiB.\n"),a("ul",[a("li",[a("em",[e._v("Note: for this rule only (not for "),a("code",[e._v("min")]),e._v(", "),a("code",[e._v("max")]),e._v(", etc), the size of the file under validation is "),a("strong",[e._v("rounded")]),e._v(" to the closest KiB.")])]),e._v(" "),a("li",[e._v("When the field is a multi-files upload, the size of "),a("strong",[e._v("all files")]),e._v(" is checked.")])])])]),e._v(" "),a("h4",{attrs:{id:"alpha"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#alpha"}},[e._v("#")]),e._v(" alpha")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be entirely alphabetic characters.")]),e._v(" "),a("h4",{attrs:{id:"alpha-dash"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#alpha-dash"}},[e._v("#")]),e._v(" alpha_dash")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be entirely alphabetic-numeric characters, dashes or underscores.")]),e._v(" "),a("h4",{attrs:{id:"alpha-num"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#alpha-num"}},[e._v("#")]),e._v(" alpha_num")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be entirely alphabetic-numeric characters.")]),e._v(" "),a("h4",{attrs:{id:"starts-with-value1"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#starts-with-value1"}},[e._v("#")]),e._v(" starts_with:value1,...")]),e._v(" "),a("p",[e._v("The field under validation must be a string and start with of the given values.")]),e._v(" "),a("h4",{attrs:{id:"ends-with-value1"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#ends-with-value1"}},[e._v("#")]),e._v(" ends_with:value1,...")]),e._v(" "),a("p",[e._v("The field under validation must be a string and end with one of the given values.")]),e._v(" "),a("h4",{attrs:{id:"in-value1-value2"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#in-value1-value2"}},[e._v("#")]),e._v(" in:value1,value2,...")]),e._v(" "),a("p",[e._v("The field under validation must be a one of the given values. Only numerics and strings are checked.")]),e._v(" "),a("h4",{attrs:{id:"not-in-value1-value2"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#not-in-value1-value2"}},[e._v("#")]),e._v(" not_in:value1,value2,...")]),e._v(" "),a("p",[e._v("The field under validation must not be a one of the given values. Only numerics and strings are checked.")]),e._v(" "),a("h4",{attrs:{id:"in-array-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#in-array-field"}},[e._v("#")]),e._v(" in_array:field")]),e._v(" "),a("p",[e._v("The field under validation must be a one of the values in the given "),a("code",[e._v("field")]),e._v(". Only numerics and strings are checked, and the given "),a("code",[e._v("field")]),e._v(" must be an array.")]),e._v(" "),a("h4",{attrs:{id:"not-in-array-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#not-in-array-field"}},[e._v("#")]),e._v(" not_in_array:field")]),e._v(" "),a("p",[e._v("The field under validation must not be a one of the values in the given "),a("code",[e._v("field")]),e._v(". Only numerics and strings are checked, and the given "),a("code",[e._v("field")]),e._v(" must be an array.")]),e._v(" "),a("h4",{attrs:{id:"timezone"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#timezone"}},[e._v("#")]),e._v(" timezone")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be a valid timezone. This rule converts the field to "),a("code",[e._v("*time.Location")]),e._v(" if it passes.")]),e._v(" "),a("p",[e._v("Valid timezones are:")]),e._v(" "),a("ul",[a("li",[e._v("UTC")]),e._v(" "),a("li",[e._v("Timezones from the IANA Time Zone database, such as "),a("code",[e._v("America/New_York")])])]),e._v(" "),a("p",[e._v("The time zone database needed by LoadLocation may not be present on all systems, especially non-Unix systems. The rules looks in the directory or uncompressed zip file\nnamed by the "),a("code",[e._v("ZONEINFO")]),e._v(" environment variable, if any, then looks in known installation locations on Unix systems, and finally looks in "),a("code",[e._v("$GOROOT/lib/time/zoneinfo.zip")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"ip"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#ip"}},[e._v("#")]),e._v(" ip")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be either an IPv4 address or an IPv6 address.\nThis rule converts the field to "),a("code",[e._v("net.IP")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"ipv4"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#ipv4"}},[e._v("#")]),e._v(" ipv4")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be an IPv4 address.\nThis rule converts the field to "),a("code",[e._v("net.IP")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"ipv6"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#ipv6"}},[e._v("#")]),e._v(" ipv6")]),e._v(" "),a("p",[e._v("The field under validation must be a string and be an IPv6 address.\nThis rule converts the field to "),a("code",[e._v("net.IP")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"json"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#json"}},[e._v("#")]),e._v(" json")]),e._v(" "),a("p",[e._v("The field under validation must be a valid JSON string. This rule unmarshals the string and sets the field value to the unmarshalled result.")]),e._v(" "),a("h4",{attrs:{id:"url"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#url"}},[e._v("#")]),e._v(" url")]),e._v(" "),a("p",[e._v("The field under validation must be a valid URL.\nThis rule converts the field to "),a("code",[e._v("*url.URL")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"uuid-version"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#uuid-version"}},[e._v("#")]),e._v(" uuid:version")]),e._v(" "),a("p",[e._v("The field under validation must be a string and a valid UUID.")]),e._v(" "),a("p",[e._v("The "),a("code",[e._v("version")]),e._v(" parameter is "),a("strong",[e._v("optional")]),e._v(".")]),e._v(" "),a("ul",[a("li",[e._v("If a "),a("code",[e._v("version")]),e._v(" is given ("),a("code",[e._v("uuid:3")]),e._v(","),a("code",[e._v("uuid:4")]),e._v(","),a("code",[e._v("uuid:5")]),e._v("), the rule will pass only if the version of the UUID matches.")]),e._v(" "),a("li",[e._v("If no "),a("code",[e._v("version")]),e._v(" is given, any UUID version is accepted.")])]),e._v(" "),a("p",[e._v("This rule converts the field to "),a("code",[e._v("uuid.UUID")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"bool"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#bool"}},[e._v("#")]),e._v(" bool")]),e._v(" "),a("p",[e._v("The field under validation must be a boolean or one of the following values:")]),e._v(" "),a("ul",[a("li",[a("code",[e._v("1")]),e._v("/"),a("code",[e._v("0")])]),e._v(" "),a("li",[a("code",[e._v('"1"')]),e._v("/"),a("code",[e._v('"0"')])]),e._v(" "),a("li",[a("code",[e._v('"on"')]),e._v("/"),a("code",[e._v('"off"')])]),e._v(" "),a("li",[a("code",[e._v('"true"')]),e._v("/"),a("code",[e._v('"false"')])]),e._v(" "),a("li",[a("code",[e._v('"yes"')]),e._v("/"),a("code",[e._v('"no"')])])]),e._v(" "),a("p",[e._v("This rule converts the field to "),a("code",[e._v("bool")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"same-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#same-field"}},[e._v("#")]),e._v(" same:field")]),e._v(" "),a("p",[e._v("The field under validation must have the same value as the given "),a("code",[e._v("field")]),e._v(". For arrays, the two fields must have the same values in the same order.")]),e._v(" "),a("p",[e._v("The two fields must have the same type. Files are not checked.")]),e._v(" "),a("h4",{attrs:{id:"different-field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#different-field"}},[e._v("#")]),e._v(" different:field")]),e._v(" "),a("p",[e._v("The field under validation must have a different value from the given "),a("code",[e._v("field")]),e._v(". For arrays, the two fields must have different values or not be in the same order.")]),e._v(" "),a("p",[e._v("The two fields must have the same type. Files are not checked.")]),e._v(" "),a("h4",{attrs:{id:"confirmed"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#confirmed"}},[e._v("#")]),e._v(" confirmed")]),e._v(" "),a("p",[e._v("The field under validation must have a matching "),a("code",[e._v("foo_confirmation")]),e._v(". This rule validate equality in the same way as the "),a("a",{attrs:{href:"#same-field"}},[a("code",[e._v("same")])]),e._v(" rule.")]),e._v(" "),a("p",[e._v("For example, if the field under validation is "),a("code",[e._v("password")]),e._v(", a matching "),a("code",[e._v("password_confirmation")]),e._v(" field must be present in the input.")]),e._v(" "),a("h4",{attrs:{id:"file"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#file"}},[e._v("#")]),e._v(" file")]),e._v(" "),a("p",[e._v("The field under validation must be a file. Multi-files are supported.\nThis rule converts the field to "),a("code",[e._v("[]filesystem.File")]),e._v(" if it passes.")]),e._v(" "),a("h4",{attrs:{id:"mime-foo"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#mime-foo"}},[e._v("#")]),e._v(" mime:foo,...")]),e._v(" "),a("p",[e._v("The field under validation must be a file and match one of the given MIME types. If the field is a multi-files, all files must satisfy this rule.")]),e._v(" "),a("h4",{attrs:{id:"image"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#image"}},[e._v("#")]),e._v(" image")]),e._v(" "),a("p",[e._v("The field under validation must be a file and match one of the following MIME types:")]),e._v(" "),a("ul",[a("li",[a("code",[e._v("image/jpeg")])]),e._v(" "),a("li",[a("code",[e._v("image/png")])]),e._v(" "),a("li",[a("code",[e._v("image/gif")])]),e._v(" "),a("li",[a("code",[e._v("image/bmp")])]),e._v(" "),a("li",[a("code",[e._v("image/svg+xml")])]),e._v(" "),a("li",[a("code",[e._v("image/webp")])])]),e._v(" "),a("p",[e._v("If the field is a multi-files, all files must satisfy this rule.")]),e._v(" "),a("h4",{attrs:{id:"extension-foo"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#extension-foo"}},[e._v("#")]),e._v(" extension:foo,...")]),e._v(" "),a("p",[e._v("The field under validation must be a file and match one of the given extensions. If the field is a multi-files, all files must satisfy this rule.")]),e._v(" "),a("h4",{attrs:{id:"count-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#count-value"}},[e._v("#")]),e._v(" count:value")]),e._v(" "),a("p",[e._v("The field under validation must be a multi-file and contain "),a("code",[e._v("value")]),e._v(" files.")]),e._v(" "),a("h4",{attrs:{id:"count-min-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#count-min-value"}},[e._v("#")]),e._v(" count_min:value")]),e._v(" "),a("p",[e._v("The field under validation must be a multi-file and contain at least "),a("code",[e._v("value")]),e._v(" files.")]),e._v(" "),a("h4",{attrs:{id:"count-max-value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#count-max-value"}},[e._v("#")]),e._v(" count_max:value")]),e._v(" "),a("p",[e._v("The field under validation must be a multi-file and may not contain more than "),a("code",[e._v("value")]),e._v(" files.")]),e._v(" "),a("h4",{attrs:{id:"count-between-min-max"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#count-between-min-max"}},[e._v("#")]),e._v(" count_between:min,max")]),e._v(" "),a("p",[e._v("The field under validation must be a multi-file and contain between "),a("code",[e._v("min")]),e._v(" and "),a("code",[e._v("max")]),e._v(" files.")]),e._v(" "),a("h4",{attrs:{id:"date-format"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#date-format"}},[e._v("#")]),e._v(" date:format")]),e._v(" "),a("p",[e._v("The field under validation must be a string representing a date. The "),a("code",[e._v("format")]),e._v(" is optional. If no format is given, the "),a("code",[e._v("2006-01-02")]),e._v(" format is used.")]),e._v(" "),a("p",[e._v("This rule converts the field to "),a("code",[e._v("time.Time")]),e._v(" if it passes.")]),e._v(" "),a("div",{staticClass:"custom-block tip"},[a("p",{staticClass:"custom-block-title"},[e._v("TIP")]),e._v(" "),a("p",[e._v("See the "),a("a",{attrs:{href:"https://golang.org/src/time/format.go",target:"_blank",rel:"noopener noreferrer"}},[e._v("Golang datetime format"),a("OutboundLink")],1),e._v(".")])]),e._v(" "),a("div",{staticClass:"custom-block warning"},[a("p",{staticClass:"custom-block-title"},[e._v("WARNING")]),e._v(" "),a("p",[e._v("When validating dates by comparing them together, the order of the declaration of the fields in the request is important. For example, if you want to validate that an end date is after a start date, the start date should be decalred "),a("strong",[e._v("before")]),e._v(" the end date in the rules set.")]),e._v(" "),a("p",[e._v("If a date has not been validated and converted yet, the date comparison rules will attempt to parse the dates using the following format: "),a("code",[e._v("2006-01-02")]),e._v(".")])]),e._v(" "),a("h4",{attrs:{id:"before-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#before-date"}},[e._v("#")]),e._v(" before:date")]),e._v(" "),a("p",[e._v("The field under validation must be a value preceding the given date. The "),a("code",[e._v("date")]),e._v(" must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a "),a("code",[e._v("date")]),e._v(", then the two fields must be a date and the field under validation must be preceding the given field.")]),e._v(" "),a("h4",{attrs:{id:"before-equal-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#before-equal-date"}},[e._v("#")]),e._v(" before_equal:date")]),e._v(" "),a("p",[e._v("The field under validation must be a value preceding or equal to the given date. The "),a("code",[e._v("date")]),e._v(" must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a "),a("code",[e._v("date")]),e._v(", then the two fields must be a date and the field under validation must be preceding or equal to given field.")]),e._v(" "),a("h4",{attrs:{id:"after-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#after-date"}},[e._v("#")]),e._v(" after:date")]),e._v(" "),a("p",[e._v("The field under validation must be a value after the given date. The "),a("code",[e._v("date")]),e._v(" must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a "),a("code",[e._v("date")]),e._v(", then the two fields must be a date and the field under validation must be preceding the given field.")]),e._v(" "),a("h4",{attrs:{id:"after-equal-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#after-equal-date"}},[e._v("#")]),e._v(" after_equal:date")]),e._v(" "),a("p",[e._v("The field under validation must be a value after or equal to the given date. The "),a("code",[e._v("date")]),e._v(" must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a "),a("code",[e._v("date")]),e._v(", then the two fields must be a date and the field under validation must be after or equal to given field.")]),e._v(" "),a("h4",{attrs:{id:"date-equals-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#date-equals-date"}},[e._v("#")]),e._v(" date_equals:date")]),e._v(" "),a("p",[e._v("The field under validation must be a value equal to the given date. The "),a("code",[e._v("date")]),e._v(" must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a "),a("code",[e._v("date")]),e._v(", then the two fields must be a date and the field under validation must be equal to given field.")]),e._v(" "),a("h4",{attrs:{id:"date-between-date1-date2"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#date-between-date1-date2"}},[e._v("#")]),e._v(" date_between:date1,date2")]),e._v(" "),a("p",[e._v("The field under validation must be a value between or equal to the given dates. The given dates must be written using following format: "),a("code",[e._v("2006-01-02T15:04:05")]),e._v(".")]),e._v(" "),a("p",[e._v("If the name of another field is given as a date, then all the fields must be a date and the field under validation must be between or equal to given fields.")]),e._v(" "),a("h2",{attrs:{id:"custom-rules"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#custom-rules"}},[e._v("#")]),e._v(" Custom rules")]),e._v(" "),a("p",[e._v("If none of the available validation rules satisfy your needs, you can implement custom validation rules. To do so, create a new file "),a("code",[e._v("http/requests/validation.go")]),e._v(" in which you are going to define your custom rules.")]),e._v(" "),a("p",[e._v("Rules definition shouldn't be exported, and start with "),a("code",[e._v("validate")]),e._v(". A rule returns a "),a("code",[e._v("bool")]),e._v(", indicating if the validation passed or not.")]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("func")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("validateCustomFormat")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("field "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" value "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("interface")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" parameters "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" form "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("map")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("interface")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("bool")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n    "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v("// Ensure the rule has at least one parameter")]),e._v("\n    validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("RequireParametersCount")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"custom_format"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" parameters"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("1")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n    str"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" ok "),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v(":=")]),e._v(" value"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n\n    "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("if")]),e._v(" ok "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v("// The data under validation is a string")]),e._v("\n        "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("return")]),e._v(" regexp"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("MustCompile")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("parameters"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("0")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("MatchString")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("str"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n    "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n\n    "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("return")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token boolean"}},[e._v("false")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v("// Cannot validate this field")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n")])])]),a("div",{staticClass:"custom-block tip"},[a("p",{staticClass:"custom-block-title"},[e._v("TIP")]),e._v(" "),a("ul",[a("li",[a("code",[e._v("validation.Rule")]),e._v(" is an alias for "),a("code",[e._v("func(string, interface{}, []string, map[string]interface{}) bool")])]),e._v(" "),a("li",[e._v("The "),a("code",[e._v("form")]),e._v(" parameter lets you access the whole form data, and modify it if needed.")]),e._v(" "),a("li",[e._v("The custom rule in the example above validates a string using a regex. If you need this kind of validation, prefer the included "),a("code",[e._v("regex")]),e._v(" validation rule.")])])]),e._v(" "),a("p",[e._v("Now that your rule behavior is defined, you need to "),a("strong",[e._v("register")]),e._v(" your rule. Do this in an "),a("code",[e._v("init()")]),e._v(" function in your "),a("code",[e._v("validation.go")]),e._v(" file.")]),e._v(" "),a("h4",{attrs:{id:"validation-addrule"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#validation-addrule"}},[e._v("#")]),e._v(" validation.AddRule")]),e._v(" "),a("p",[e._v("Register a validation rule.")]),e._v(" "),a("p",[e._v("The rule will be usable in request validation by using the given rule name.")]),e._v(" "),a("p",[e._v('Type-dependent messages let you define a different message for numeric, string, arrays and files. The language entry used will be "validation.rules.rulename.type"')]),e._v(" "),a("table",[a("thead",[a("tr",[a("th",[e._v("Parameters")]),e._v(" "),a("th",[e._v("Return")])])]),e._v(" "),a("tbody",[a("tr",[a("td",[a("code",[e._v("name string")])]),e._v(" "),a("td",[a("code",[e._v("void")])])]),e._v(" "),a("tr",[a("td",[a("code",[e._v("typeDependentMessage bool")])]),e._v(" "),a("td")]),e._v(" "),a("tr",[a("td",[a("code",[e._v("rule validation.Rule")])]),e._v(" "),a("td")])])]),e._v(" "),a("p",[a("strong",[e._v("Example:")])]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("func")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("init")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n    validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("AddRule")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"custom_format"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token boolean"}},[e._v("false")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" validateCustomFormat"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n")])])]),a("h4",{attrs:{id:"validation-requireparameterscount"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#validation-requireparameterscount"}},[e._v("#")]),e._v(" validation.RequireParametersCount")]),e._v(" "),a("p",[e._v("Checks if the given parameters slice has at least "),a("code",[e._v("count")]),e._v(" elements. If this criteria is not met, the function triggers a panic.")]),e._v(" "),a("p",[e._v("Use this to make sure your validation rules are correctly used.")]),e._v(" "),a("table",[a("thead",[a("tr",[a("th",[e._v("Parameters")]),e._v(" "),a("th",[e._v("Return")])])]),e._v(" "),a("tbody",[a("tr",[a("td",[a("code",[e._v("rule string")])]),e._v(" "),a("td",[a("code",[e._v("void")])])]),e._v(" "),a("tr",[a("td",[a("code",[e._v("params []string")])]),e._v(" "),a("td")]),e._v(" "),a("tr",[a("td",[a("code",[e._v("count int")])]),e._v(" "),a("td")])])]),e._v(" "),a("p",[a("strong",[e._v("Example:")])]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[e._v("validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("RequireParametersCount")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"custom_format"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" parameters"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("1")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n")])])]),a("h4",{attrs:{id:"validation-getfieldtype"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#validation-getfieldtype"}},[e._v("#")]),e._v(" validation.GetFieldType")]),e._v(" "),a("p",[a("Badge",{attrs:{text:"Since v2.0.0"}})],1),e._v(" "),a("p",[e._v("returns the non-technical type of the given "),a("code",[e._v("value")]),e._v(" interface.\nThis is used by validation rules to know if the input data is a candidate\nfor validation or not and is especially useful for type-dependent rules.")]),e._v(" "),a("ul",[a("li",[a("code",[e._v("numeric")]),e._v(" if the value is an int, uint or a float")]),e._v(" "),a("li",[a("code",[e._v("string")]),e._v(" if the value is a string")]),e._v(" "),a("li",[a("code",[e._v("array")]),e._v(" if the value is a slice")]),e._v(" "),a("li",[a("code",[e._v("file")]),e._v(" if the value is a slice of "),a("code",[e._v("filesystem.File")])]),e._v(" "),a("li",[a("code",[e._v("unsupported")]),e._v(" otherwise")])]),e._v(" "),a("table",[a("thead",[a("tr",[a("th",[e._v("Parameters")]),e._v(" "),a("th",[e._v("Return")])])]),e._v(" "),a("tbody",[a("tr",[a("td",[a("code",[e._v("value interface{}")])]),e._v(" "),a("td",[a("code",[e._v("string")])])])])]),e._v(" "),a("p",[a("strong",[e._v("Example:")])]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[e._v("validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("GetFieldType")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"foo"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v('// "string"')]),e._v("\nvalidation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("GetFieldType")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("2")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v('// "numeric"')]),e._v("\nvalidation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("GetFieldType")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("2.4")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v('// "numeric"')]),e._v("\nvalidation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("GetFieldType")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("int")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("1")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("2")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v('// "array"')]),e._v("\n")])])]),a("h2",{attrs:{id:"placeholders"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#placeholders"}},[e._v("#")]),e._v(" Placeholders")]),e._v(" "),a("p",[e._v("Validation messages can use placeholders to inject dynamic values in the validation error message. For example, in the "),a("code",[e._v("rules.json")]),e._v(" language file:")]),e._v(" "),a("div",{staticClass:"language-json extra-class"},[a("pre",{pre:!0,attrs:{class:"language-json"}},[a("code",[a("span",{pre:!0,attrs:{class:"token property"}},[e._v('"between.string"')]),a("span",{pre:!0,attrs:{class:"token operator"}},[e._v(":")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"The :field must be between :min and :max characters."')]),e._v("\n")])])]),a("p",[e._v("Here, the "),a("code",[e._v(":field")]),e._v(" placeholder will be replaced by the field name, "),a("code",[e._v(":min")]),e._v("  with the first parameter and "),a("code",[e._v(":max")]),e._v(" with the second parameter, effectively giving the following result:")]),e._v(" "),a("div",{staticClass:"language- extra-class"},[a("pre",{pre:!0,attrs:{class:"language-text"}},[a("code",[e._v("The password must be between 6 and 32 characters. \n")])])]),a("p",[e._v("Placeholders are "),a("strong",[e._v("replacer functions")]),e._v(". In fact, "),a("code",[e._v("validation.Placeholder")]),e._v(" is an alias for "),a("code",[e._v("func(string, string, []string, string) string")]),e._v(". These functions should return the value to replace the placeholder with.")]),e._v(" "),a("p",[a("strong",[e._v("Example:")])]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("func")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("simpleParameterPlaceholder")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("field "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" rule "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" parameters "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" language "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n\t"),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("return")]),e._v(" parameters"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("0")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),e._v("\n")])])]),a("hr"),e._v(" "),a("p",[e._v("Placeholders are implemented in the "),a("code",[e._v("http/requests/placeholders.go")]),e._v(". To register a custom placeholder, use the "),a("code",[e._v("validation.SetPlaceholder()")]),e._v(" function, preferably in the "),a("code",[e._v("init()")]),e._v(" function of your "),a("code",[e._v("placeholders.go")]),e._v(" file.")]),e._v(" "),a("h4",{attrs:{id:"validation-setplaceholder"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#validation-setplaceholder"}},[e._v("#")]),e._v(" validation.SetPlaceholder")]),e._v(" "),a("p",[e._v("Sets the replacer function for the given placeholder. Don't include the colon prefix in the placeholder name.")]),e._v(" "),a("p",[e._v("If a placeholder with this name already exists, the latter will be overridden.")]),e._v(" "),a("table",[a("thead",[a("tr",[a("th",[e._v("Parameters")]),e._v(" "),a("th",[e._v("Return")])])]),e._v(" "),a("tbody",[a("tr",[a("td",[a("code",[e._v("placeholderName string")])]),e._v(" "),a("td",[a("code",[e._v("void")])])]),e._v(" "),a("tr",[a("td",[a("code",[e._v("replacer validation.Placeholder")])]),e._v(" "),a("td")])])]),e._v(" "),a("p",[a("strong",[e._v("Example:")])]),e._v(" "),a("div",{staticClass:"language-go extra-class"},[a("pre",{pre:!0,attrs:{class:"language-go"}},[a("code",[e._v("validation"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(".")]),a("span",{pre:!0,attrs:{class:"token function"}},[e._v("SetPlaceholder")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),a("span",{pre:!0,attrs:{class:"token string"}},[e._v('"min"')]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("func")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("(")]),e._v("field "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" rule "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" parameters "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(",")]),e._v(" language "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token builtin"}},[e._v("string")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("{")]),e._v("\n  \t"),a("span",{pre:!0,attrs:{class:"token keyword"}},[e._v("return")]),e._v(" parameters"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("[")]),a("span",{pre:!0,attrs:{class:"token number"}},[e._v("0")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("]")]),e._v(" "),a("span",{pre:!0,attrs:{class:"token comment"}},[e._v('// Replace ":min" by the first parameter in the rule definition')]),e._v("\n"),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v("}")]),a("span",{pre:!0,attrs:{class:"token punctuation"}},[e._v(")")]),e._v("\n")])])]),a("h3",{attrs:{id:"available-placeholders"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#available-placeholders"}},[e._v("#")]),e._v(" Available placeholders")]),e._v(" "),a("h4",{attrs:{id:"field"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#field"}},[e._v("#")]),e._v(" :field")]),e._v(" "),a("p",[a("code",[e._v(":field")]),e._v(" is replaced by the name of the field. If it exists, the replacer with favor the language lines in "),a("code",[e._v("fields.json")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"other"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#other"}},[e._v("#")]),e._v(" :other")]),e._v(" "),a("p",[a("code",[e._v(":other")]),e._v(" is replaced by the name of the field given as first parameter in the rule definition. If it exists, the replacer with favor the language lines in "),a("code",[e._v("fields.json")]),e._v(".")]),e._v(" "),a("p",[e._v("For example, the "),a("code",[e._v("same:password_confirmation")]),e._v(" rule compares two fields together and returns the following message if the validation fails:")]),e._v(" "),a("div",{staticClass:"language- extra-class"},[a("pre",{pre:!0,attrs:{class:"language-text"}},[a("code",[e._v("The :field and the :other must match.\n\nThe password and the password confirmation must match.\n")])])]),a("h4",{attrs:{id:"value"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#value"}},[e._v("#")]),e._v(" :value")]),e._v(" "),a("p",[a("code",[e._v(":value")]),e._v(" is replaced by the first parameter of the rule definition.")]),e._v(" "),a("h4",{attrs:{id:"values"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#values"}},[e._v("#")]),e._v(" :values")]),e._v(" "),a("p",[a("code",[e._v(":values")]),e._v(" is replaced by a concatenation of all rule parameters, joined by a comma.")]),e._v(" "),a("h4",{attrs:{id:"min"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#min"}},[e._v("#")]),e._v(" :min")]),e._v(" "),a("p",[a("code",[e._v(":min")]),e._v(" is replaced by the first parameter of the rule definition.")]),e._v(" "),a("h4",{attrs:{id:"max"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#max"}},[e._v("#")]),e._v(" :max")]),e._v(" "),a("p",[a("code",[e._v(":max")]),e._v(" is replaced by the first parameter of the rule definition, or the second if the rule name contains "),a("code",[e._v("between")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"version"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#version"}},[e._v("#")]),e._v(" :version")]),e._v(" "),a("p",[a("code",[e._v(":version")]),e._v(" is replaced by a concatenation of "),a("code",[e._v("v")]),e._v(" and the first parameter of the rule definition, or by an empty string if the rule doesn't have any parameter.")]),e._v(" "),a("p",[e._v("For example, for the "),a("code",[e._v("UUID:4")]),e._v(" rule, the result would be "),a("code",[e._v("v4")]),e._v(".")]),e._v(" "),a("h4",{attrs:{id:"date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#date"}},[e._v("#")]),e._v(" :date")]),e._v(" "),a("p",[a("code",[e._v(":date")]),e._v(" is replaced by the first parameter of the rule definition. If the first parameter is a field name, "),a("code",[e._v(":date")]),e._v(" will be replaced with the name of the field in the same way as the "),a("code",[e._v(":other")]),e._v(" placeholder.")]),e._v(" "),a("h4",{attrs:{id:"max-date"}},[a("a",{staticClass:"header-anchor",attrs:{href:"#max-date"}},[e._v("#")]),e._v(" :max_date")]),e._v(" "),a("p",[a("code",[e._v(":max_date")]),e._v(" is replaced by the second parameter of the rule definition. If the second parameter is a field name, "),a("code",[e._v(":max_date")]),e._v(" will be replaced with the name of the field in the same way as the "),a("code",[e._v(":other")]),e._v(" placeholder.")])])}),[],!1,null,null,null);t.default=n.exports}}]);